package.loaded.Constants = nil; require("Constants");

-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

function FiringRangeMission:StartActivity()
	print("START! -- FiringRangeMission:StartActivity()!");
	self.braindead = {};
	self.AssignedBrains = {};
	self.MOIDLimit = 175;
	self.Zone = SceneMan.Scene:GetArea("LZ");
	self.Zone = SceneMan.Scene:GetArea("Button");
	self.RespawnTimer = Timer();
	self.PlayerGold = 1000000; -- Player starting credits
   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;
	self.disabled = 1
	for player = 0, self.PlayerCount - 1 do
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CreateAHuman("Brain Robot" , "base.rte");
			brain.Pos = Vector(3200, 475);
			brain:AddInventoryItem(CreateHDFirearm("Assault Rifle" , "Coalition.rte"));
			brain.AIMode = Actor.AIMODE_SENTRY;
			self.AssignedBrains[player] = brain;

            MovableMan:AddActor(brain);
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
			self:SwitchToActor(brain, player, self.PlayerTeam);
        end
    end
	
	self.ButtonZone = SceneMan.Scene:GetArea("Button");
	
    self:SetTeamFunds(self.PlayerGold , self.PlayerTeam);
end

-----------------------------------------------------------------------------------------

function FiringRangeMission:PauseActivity(pause)
    print("PAUSE! -- FiringRangeMission:PauseActivity()!");
end

-----------------------------------------------------------------------------------------

function FiringRangeMission:EndActivity()
    print("END! -- FiringRangeMission:EndActivity()!");
end

-----------------------------------------------------------------------------------------

function FiringRangeMission:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
	
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					FrameMan:SetScreenText("Commander died!", player, 100, -1, false);
					self.braindead[player] = true;
					
					self.WinnerTeam = self:OtherTeam(team);
					ActivityMan:EndActivity();
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end --if
end

----------------------------------------------------------------------------------------

function FiringRangeMission:UpdateActivity()
   	self:Respawn();
end

----------------------------------------------------------------------------------------

function FiringRangeMission:Respawn()

	self.disabled = 1
	
	for actor in MovableMan.Actors do
		if self.ButtonZone:IsInside(actor.Pos) then
			self.disabled = 0
		end
	end
		
	if self.RespawnTimer:IsPastSimMS(5000) then
	print("Step 1");	
		if self.disabled == 0 then
		print("Step 2");
			if MovableMan:GetMOIDCount() <= self.MOIDLimit then
				print("Step 3");
				local actor = nil;
				if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
						actor = CreateAHuman("Culled Clone");
					elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
							actor = CreateAHuman("Dummy");
					elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
						actor = CreateAHuman("Dafred");
					elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
						actor = CreateAHuman("Soldier Light");
					elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then 
						actor = CreateAHuman("Combat Robot");
					elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
						actor = CreateAHuman("Browncoat Heavy");
				end -- if, actor selection
				actor.AIMode = Actor.AIMODE_GOTO;
				actor:ClearAIWaypoints();
				actor:AddAISceneWaypoint(Vector(3504 , 732));
				actor.Pos = Vector(3912, 636);
				actor.Team = self.CPUTeam;
				MovableMan:AddActor(actor);
			end -- if, MOID check
		end -- if, button disabler
	self.RespawnTimer:Reset();
	end  --if, timer
	
	self:ClearObjectivePoints();
	
	if self.disabled == 0 then
		self:AddObjectivePoint("Spawner active", Vector(3804, 487), Activity.TEAM_1, GameActivity.ARROWDOWN);
	end
	
	if self.disabled == 1 then
		self:AddObjectivePoint("Spawner disabled", Vector(3804, 487), Activity.TEAM_1, GameActivity.ARROWDOWN);
	end
end --function